<?php

define("REG_DATA_REQUEST",			1);
define("REG_DATA_SUBMIT",			2);
define("REG_ASSISTANCE_REQUEST",	3);
define("CAL_UPLOAD_REQUEST",		4);
define("CAL_CONFIRM_REQUEST",		5);
define("AUTH_REQUEST",				6);


define("REQUEST_INVALID",	2);
define("REQUEST_SUCCESS",	1);
define("REQUEST_FAILURE",	0);

define("CALIBRATION_LOGS_EMAIL", "Registration@XXX.com, filip.kujikis@XXX.com");
define("REGISTRATION_EMAIL","Registration@XXX.com, filip.kujikis@XXX.com");
//define("REGISTRATION_EMAIL","Registration@XXX.com");

// Determine whether debugging info should be sent back or witheld
$ENABLE_DEBUG = false;

function checkRequiredPOSTParamsExist($requestType)
{
	if($_POST == null) return;
	$requiredParams = null;
	
	if($requestType == REG_DATA_REQUEST)
	{
		$requiredParams = array( "SerialNum" => 1); 	
	}
	else if($requestType == REG_ASSISTANCE_REQUEST)
	{
		$requiredParams = array( "SerialNum" => 1, "name" => 1, "phone" => 1, "email" => 1); 
	}
	else if($requestType == REG_DATA_SUBMIT)
	{
		$requiredParams = array("ContactName" => 1,	"CompanyName" => 1,		"ad_Street" => 1,
								"ad_City" => 1,		"ad_Zip" => 1,			"ad_Country" => 1,
	  						 	"email" => 1,		"phone" => 1,			"distributorName" => 1,
	  						 	"SerialNum" => 1,	"magic" => 1); 		
	}
	else if($requestType == CAL_UPLOAD_REQUEST)
	{
		$requiredParams = array("SerialNum" => 1,
								"Username" => 1,		"Password" => 1,
								"calLog_0ppm" => 1,		"calLog_20ppm" => 1, 
								"calValue_0ppm" => 1,	"calValue_20ppm" => 1); 
	}
	else if($requestType == CAL_CONFIRM_REQUEST)
	{
		$requiredParams = array( "SerialNum" => 1, 	"confirmation_id" => 1,
								 "Username" => 1, 	"Password" => 1); 	
	}
	else if($requestType == AUTH_REQUEST)
	{
		$requiredParams = array( "SerialNum" => 1, 
								 "Username" => 1, 	"Password" => 1); 	
	}

				 
	if($requiredParams == null) return false;
				 
 	$requiredParamsExist = true;
	reset($requiredParams);					 
	while($requiredParamsExist && (list($key,$value)=each($requiredParams)))
	{
		$requiredParamsExist &=	($_POST[$key] != null);
	}	
	return $requiredParamsExist;
}

$requestValidationLog;
function validatePOSTParams($requestType)
{
	global $requestValidationLog;
	$requestValidationLog = "";
	
	if($_POST == null)
	{ 
		$requestValidationLog .= "POST was null.";
		return;
	}
	
	$paramsValid = true;
	
	$paramsValid &= checkRequiredPOSTParamsExist($requestType);
	
	$requestValidationLog .= "[Required params exist : $paramsValid ]";
	
	$serialHash = $_POST["magic"];
	$serial = $_POST["SerialNum"];
	
	// Ensure that both the serial number and its hash have been read
	$paramsValid &= ($serial != null && is_numeric($serial)) && ($serialHash != null);
	$hashSalt = "";
	
	$requestValidationLog .=  "[Serial and hash ok : $paramsValid ]";
		
	reset($_POST);
	while(list($key, $value)=each($_POST))
	{
		if($key != "magic")
		{
			// Ensure we have desired length
			$paramsValid &= (strlen($value) >= 1);
			// build up hash salt - first character of posted parameters
			$hashSalt .= substr($value,0,1);
		}
	}
	$requestValidationLog .= "[ Loop ok : $paramsValid ]";
		
	// ensure email has been correctly entered
	
	if($_POST["email"] != null)
	{	
		$paramsValid &= true;
		$requestValidationLog .=  "[ Email ok : $paramsValid - email: " . $_POST["email"] . " ]";
	}

 	// validate data received against provided hash code	
	$hash = md5($hashSalt . $serial);
	
	
	
	$paramsValid &= (strcasecmp($serialHash,$hash) == 0);
	
	$requestValidationLog .=  "[ Hash compare ok : $paramsValid ($hashSalt, $serialHash, $hash) ]";
	
	return $paramsValid;
}

function genXMLDebugElement($debugString)
{
	global $ENABLE_DEBUG;
	if($ENABLE_DEBUG)
	{
		return "<Debug> $debugString </Debug>";
	}
}

function genXMLResponseElement($responseCode, $innerXML)
{
	return "<Response code='$responseCode'>$innerXML</Response>";	
}

?>