<?php
include_once('appl_request_interface.php');

function emailCalibrationLogUpload($serial, $log0ppm, $log20ppm, $cal0ppm, $cal20ppm, $userId)
{	
	// Include the last 15 log lines in the notification e-mail.
	$numLogLinesForEmail = 15;
	
	$emailString = "A calibration log has been uploaded for a device. \r\n";
	$emailString .= "\r\n";
	$emailString .= "0 ppm Calibration value: $cal0ppm \r\n";
	$emailString .= "20 ppm Calibration value: $cal20ppm \r\n";
	$emailString .= "User ID: $userId \r\n";
	$emailString .= "Device serial: $serial \r\n";
	$emailString .= "\r\n";
	
	//================================================================================================
	
	$tokens_0ppm = explode(("\r\n"),$log0ppm);
	$tokens_0ppm_count = count($tokens_0ppm);
	$sendLog_0ppm = "";
		
	if($tokens_0ppm_count > $numLogLinesForEmail)
	{
		for($i = $tokens_0ppm_count - $numLogLinesForEmail; $i < $tokens_0ppm_count ; $i++)
		{
			$sendLog_0ppm .= $tokens_0ppm[$i] . "\r\n";
		}
	}
	else
	{
		$sendLog_0ppm = $log0ppm;
	}
	
	$emailString .= "\r\n";
	$emailString .= "Last $numLogLinesForEmail points of 0-ppm Calibration: \r\n";
	$emailString .= $sendLog_0ppm;
	
	//================================================================================================
	
	$tokens_20ppm = explode(("\r\n"),$log20ppm);
	$tokens_20ppm_count = count($tokens_20ppm);
	$sendLog_20ppm = "";
		
	if($tokens_20ppm_count > $numLogLinesForEmail)
	{
		for($i = $tokens_20ppm_count - $numLogLinesForEmail; $i < $tokens_20ppm_count ; $i++)
		{
			$sendLog_20ppm .= $tokens_20ppm[$i] . "\r\n";
		}
	}
	else
	{
		$sendLog_20ppm = $log20ppm;
	}
		
	$emailString .= "\r\n";
	$emailString .= "\r\n";
	$emailString .= "Last $numLogLinesForEmail points of 20-ppm Calibration: \r\n";
	$emailString .= $sendLog_20ppm;
	

	return send_text_email(CALIBRATION_LOGS_EMAIL, 
			"Calibration received for unit " . $_POST["SerialNum"] . ".",
			$emailString,"webcalibration@XXX.com");
}

function genXMLCalLogConfirmationIdElement($confirmationId)
{
	return "<ConfirmationId> $confirmationId </ConfirmationId>";
}

// Handles requests that upload calibration logs
function handleCalibrationLogUploadRequest($userID)
{

	$sampleId = 1337;
	$sampleError = null;
	if($sampleError == null)
	{
		echo genXMLResponseElement(REQUEST_SUCCESS,
								   genXMLDebugElement($requestValidationLog)
								  .genXMLCalLogConfirmationIdElement($sampleId));
	}
	else
	{ 
		echo genXMLResponseElement(REQUEST_FAILURE,genXMLDebugElement($requestValidationLog));
	}		
}

// Handles requests that act as confirmation of log upload
function handleCalibrationConfirmationRequest($userID)
{
	// Success
	echo genXMLResponseElement(REQUEST_SUCCESS,genXMLDebugElement($requestValidationLog));
}

//==================
// PAGE ENTRY POINT
//==================
//	Summary:
//	1. Check that the request has all the required parameters.
//	2. If so, identify the user uploading the calibration data using their
//

$requestType = 0;
$postCount = count($_POST);
if($postCount == 8)
{
	// Upload request sends:
	// serial, 0ppm log, 20ppm log, 0ppm value, 20ppm value, user, password, hashcode
	$requestType = CAL_UPLOAD_REQUEST;
}
else if($postCount == 5)
{
	// Confirm request sends:
	// serial, username, password, confirmation id, hashcode
	$requestType = CAL_CONFIRM_REQUEST;
}

$postValid = false;
if(($postValid = validatePOSTParams($requestType)))
{
	$username = $_POST["Username"];
	$password = $_POST["Password"];
	// Check user can log in and get the user ID.
	//$userID = sqlUser::check_login_valid($username,$password);
	$userID = 5;
	if($userID > -1)
	{
		if($requestType == CAL_UPLOAD_REQUEST)
		{
			handleCalibrationLogUploadRequest($userID);
		}
		else if($requestType == CAL_CONFIRM_REQUEST)
		{
			handleCalibrationConfirmationRequest($userID);
		}
	}
	else
	{
		echo genXMLResponseElement(REQUEST_FAILURE,genXMLDebugElement($requestValidationLog));
	}
}
else
{	
	echo genXMLResponseElement(REQUEST_INVALID,genXMLDebugElement($requestValidationLog));	
}

?>