<?php

	include_once('appl_request_interface.php');


function emailAssistanceRequestDetails()
{
	$emailString = "A customer has requested assistance with registering their RADEX CO Monitor.\r\n";
	$emailString .= "\r\n";
	$emailString .= "Customer Name: " 	. $_POST["name"] . "\r\n";
	$emailString .= "Phone Number: " 	. $_POST["phone"] . "\r\n";
	$emailString .= "E-mail: " 			. $_POST["email"] . "\r\n";
	$emailString .= "Device serial: " 	. $_POST["SerialNum"] . "\r\n";
	if($_POST["note"] != null)
	$emailString .= "User Note: \""		. $_POST["note"] . "\"\r\n";
	
	return send_text_email(REGISTRATION_EMAIL, 
						"Registration assistance request for unit " . $_POST["SerialNum"] . ".",
								$emailString,"webregistration@XXX.com");
}

function emailRegistrationDetails($sqlRegObject)
{
	if($sqlRegObject != null && $sqlRegObject->details != null)
	{
		$emailString = "";
		reset($sqlRegObject->details);
		while(list($key,$value) = each($sqlRegObject->details))
		{
			if($value != null)
			{
				$emailString .= $key . ": " . $value . "\r\n";
			}
		}
		reset($sqlRegObject->details);
		
		return send_text_email(REGISTRATION_EMAIL, 
								"RPB RADEX registration for unit " . $sqlRegObject->details["SerialNum"] . ".",
								$emailString,"webregistration@rpbresp.com");		
	}
	return false;
}

function escapeXMLTextChars($textString)
{
/*	
    * &amp; for & (ampersand)
    * &lt; for < (left angle bracket, less-than sign)
    * &gt; for > (right angle bracket, greater-than sign)
    * &quot; for " (quotation mark)
    * &apos; for ' (apostrophe) 
    */
    $xmlEscapeChars = array("&" => "&amp;",	
							"<" => "&lt;",	
							">" => "&gt;",							 
						 	"\"" => "&quot;",
							"'" => "&apos;");
    $escapedText = $textString;
    
	while(list($key,$value) = each($xmlEscapeChars))
	{
		$escapedText = str_replace($key,$value,$escapedText);
	}
	
	return $escapedText;
}

//==================
// PAGE ENTRY POINT
//==================

$requestType = 0;
$postCount = count($_POST);
if($postCount == 3)
{
	// Registration data request sends: email, serial and hashcode
	$requestType = REG_DATA_REQUEST;
}
else if($postCount == 5 || $postCount == 6)
{
	// Registration assistance request sends: email, phone, name, serial, hash and optional note.
	$requestType = REG_ASSISTANCE_REQUEST;	

}
else 
{
	$requestType = REG_DATA_SUBMIT;
}

//echo "<BR> Post count: $postCount request: $requestType <BR>";

$postValid = false;
if((true))
{
	if($requestType == REG_DATA_SUBMIT)
	{
		echo genXMLResponseElement(REQUEST_SUCCESS,genXMLDebugElement($requestValidationLog));
	}
	else if($requestType == REG_DATA_REQUEST)
	{
		$requiredParams = array("ContactName" => "Jim",	"CompanyName" => "Jim's Firm",		"ad_Street" => "Address",
								"ad_City" => "City",		"ad_Zip" => "1231",			"ad_Country" => "USA",
	  						 	"email" => "jim@aol.com",		"phone" => "123123",			"distributorName" => "XXX USA",
	  						 	"SerialNum" => "123"); 	
		
		$xml = "<Registration>";
			
		reset($requiredParams);
		while(list($key,$value) = each($requiredParams))
		{
			if($value != null)
			{
				$xmlText = escapeXMLTextChars($value);
				$xml .= "<$key>$xmlText</$key>";
			}
		}	
		$xml .= "</Registration>";
	
		// E-mail matches latest registration for device.
		echo genXMLResponseElement(REQUEST_SUCCESS,$xml . genXMLDebugElement($requestValidationLog));

	}
	else if($requestType == REG_ASSISTANCE_REQUEST)
	{
		echo genXMLResponseElement(REQUEST_SUCCESS,genXMLDebugElement($requestValidationLog));
	}
}
else
{	
	echo genXMLResponseElement(REQUEST_INVALID,genXMLDebugElement($requestValidationLog));	
}

?>